stages:
  - build
  - linter
  - sonar_cloud

build:
  stage: build
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw package
  artifacts:
    paths:
      - target/main-0.0.1-SNAPSHOT.jar

linter:
  stage: linter
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw spotbugs:spotbugs
  dependencies:
  - build

sonar_cloud:
  stage: sonar_cloud
  image: maven:3.6.3-jdk-11
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script: 
    - mvn verify sonar:sonar -Dsonar.projectKey=sqr-inno_s23_lab-2-linter-and-sonar_AYa9uhLgfFM1YUNdN_9-
  dependencies:
    - build
    - linter
  allow_failure: true